.686p
.model	flat, stdcall
option	casemap :none

include		Beginning.inc

.code
start:
	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	invoke	DialogBoxParam, hInstance, 101, 0, ADDR DlgProc, 0
	invoke	ExitProcess, eax
; -----------------------------------------------------------------------
DlgProc	proc	hWin:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD

	mov eax,uMsg
	
	.if eax == WM_INITDIALOG
		push hWin
		pop hWindow
		
	.elseif	eax == WM_COMMAND
		
		movzx eax,word ptr [wParam]
		movzx ecx,word ptr [wParam+2]
		
		.if	eax == IDC_OK
			.if bMajChosen && bMinChosen
				invoke GetFileName
				.if eax
					invoke ChangeVersion,eax, dwNewMajOSVer, dwNewMinOSVer
					.if eax
						invoke SetDlgItemInt,hWin,IDC_ORIGINAL_MAJ_OS,dwOrigMajOSVer,FALSE
						invoke SetDlgItemInt,hWin,IDC_ORIGINAL_MIN_OS,dwOrigMinOSVer,FALSE
						invoke MessageBox,hWin,T("Operating system versions were changed successfully."), T("Procedure completed:"),MB_OK
						
					.endif
				.endif
			.else
				invoke MessageBox,hWin,T("You muse give new version information first."),T("Missing information:"),MB_OK
			.endif
		
		.elseif eax ==  IDC_NEW_MAJ_OS
			.if ecx == EN_CHANGE
				mov bMajChosen,TRUE
				invoke GetDlgItemInt,hWin,eax,NULL,FALSE
				mov dwNewMajOSVer,eax
			.endif
		
		.elseif eax == IDC_NEW_MIN_OS
			.if ecx == EN_CHANGE
				mov bMinChosen,TRUE
				invoke GetDlgItemInt,hWin,eax,NULL,FALSE
				mov dwNewMinOSVer,eax
			.endif
			
		.elseif eax == IDC_CANCEL
			invoke SendMessage,hWin,WM_CLOSE,0,0
			
		.endif
		
	.elseif	eax == WM_CLOSE
		invoke	EndDialog,hWin,0
	.endif
		
	xor	eax,eax
	ret
DlgProc	endp



SEH struct 
   PrevLink dd ? 
   CurrentHandler dd ?
   SafeOffset dd ?
   PrevEsp dd ?
   PrevEbp dd ?
SEH ends 

SEHHandler proc C pExcept:DWORD, pFrame:DWORD, pContext:DWORD, pDispatch:DWORD 
mov edx,pFrame 
assume edx:ptr SEH 
mov eax,pContext 
assume eax:ptr CONTEXT 
push [edx].SafeOffset 
pop [eax].regEip 
push [edx].PrevEsp 
pop [eax].regEsp 
push [edx].PrevEbp 
pop [eax].regEbp 
mov eax,ExceptionContinueExecution 
ret 
SEHHandler endp 

ChangeVersion	PROC	uses ebx edx esi edi lpFileName:LPSTR, dwNewMajVersion:DWORD,dwNewMinVersion:DWORD
	LOCAL hFile:DWORD
	LOCAL hFileMap:DWORD
	LOCAL lpFileMap:DWORD
	LOCAL dwResult:DWORD
	LOCAL seh:SEH
	LOCAL szNewFileName[256]:BYTE
	
	
	mov dwResult,FALSE
	
	invoke wsprintf,ADDR szNewFileName,T("%s.bak"),lpFileName
ChangeVersion_CreateBackupFile:	
	invoke CopyFile,lpFileName,ADDR szNewFileName,TRUE
	.if !eax
	
		invoke GetLastError
		.if eax == ERROR_FILE_EXISTS
		
			invoke MessageBox,hWindow,T("Backup file already exists, delete it?"),T("CopyFileA failed:"),MB_YESNO
			.if eax != 6
				jmp ChangeVersion_Exit
			.endif
			
			invoke DeleteFile,ADDR szNewFileName
			.if !eax
				invoke MessageBox,hWindow,T("Failed to delete old backup file, please ensure it is not in use and try again."),T("DeleteFileA failed:"),MB_OK
				jmp ChangeVersion_Exit
			.endif
			
			jmp ChangeVersion_CreateBackupFile
		
		.else
			invoke MessageBox,hWindow,T("Error creating backup file."), T("CopyFileA failed:"),MB_OK
			jmp ChangeVersion_Exit
		.endif
		
	.endif
	
	
	invoke CreateFile,lpFileName,GENERIC_READ OR GENERIC_WRITE OR GENERIC_ALL,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	
	mov hFile,eax
	
	.if eax == INVALID_HANDLE_VALUE
		invoke MessageBox,hWindow,T("Failed to open handle for file."),T("CreateFileA failed:"),MB_OK
		jmp ChangeVersion_Exit
	.endif
	
	invoke CreateFileMapping,hFile,NULL,PAGE_READWRITE,NULL,NULL,NULL
	mov hFileMap,eax
	.if !eax
		invoke MessageBox,hWindow,T("Failed to create file mapping object."),T("CreateFileMappingA failed:"),MB_OK
		jmp ChangeVersion_CloseFileHandle
	.endif
	
	invoke MapViewOfFile,hFileMap,FILE_MAP_WRITE,NULL,NULL,NULL
	mov lpFileMap,eax
	.if !eax
		invoke MessageBox,hWindow,T("Failed to create mapped view of file."),T("MapViewOfFile failed:"),MB_OK
		jmp ChangeVersion_CloseFileMapHandle
		
		ret
	.endif
	

	mov edi,lpFileMap
	.if IMAGE_DOS_HEADER.e_magic[edi] != IMAGE_DOS_SIGNATURE
		invoke MessageBox,hWindow,T("File has an invalid DOS signature."),T("Invalid DOS header:"),MB_OK
		jmp ChangeVersion_UnmapViewOfFile
	.endif
	
	mov esi,IMAGE_DOS_HEADER.e_lfanew[edi]
	add esi,edi
	
	assume fs:nothing 
	push fs:[0] 
	pop seh.PrevLink 
	mov seh.CurrentHandler,offset SEHHandler 
	mov seh.SafeOffset,offset ChangeVersion_SafeExit 
	lea eax,seh 
	mov fs:[0], eax 
	mov seh.PrevEsp,esp 
	mov seh.PrevEbp,ebp 
	
	.if IMAGE_NT_HEADERS.Signature[esi] != IMAGE_NT_SIGNATURE
		invoke MessageBox,hWindow,T("File has an invalid PE signature."),T("Invalid PE header:"),MB_OK
		jmp ChangeVersion_SafeExit
	.endif
	
	movzx eax, IMAGE_NT_HEADERS.OptionalHeader.MajorOperatingSystemVersion[esi]
	mov dwOrigMajOSVer,eax
	
	movzx eax, IMAGE_NT_HEADERS.OptionalHeader.MinorOperatingSystemVersion[esi]
	mov dwOrigMinOSVer,eax
	
	mov eax, dwNewMajVersion
	mov IMAGE_NT_HEADERS.OptionalHeader.MajorOperatingSystemVersion[esi],ax
	
	mov eax, dwNewMinVersion
	mov IMAGE_NT_HEADERS.OptionalHeader.MinorOperatingSystemVersion[esi],ax
	
	mov dwResult,TRUE
	
ChangeVersion_SafeExit:	
	push seh.PrevLink 
	pop fs:[0]
	assume fs:error
	
ChangeVersion_UnmapViewOfFile:	
	invoke UnmapViewOfFile,lpFileMap
	
ChangeVersion_CloseFileMapHandle:
	invoke CloseHandle,hFileMap

ChangeVersion_CloseFileHandle:
	invoke CloseHandle,hFile

ChangeVersion_Exit:	
	
	mov eax,dwResult
	Ret
ChangeVersion EndP





GetFileName Proc
	LOCAL	OFN:OPENFILENAME
	
    invoke RtlZeroMemory,ADDR OFN,sizeof OFN
    
    mov OFN.lStructSize, sizeof OPENFILENAME
    push hWindow
    pop OFN.hWndOwner
    mov OFN.lpstrFilter, T("Executable Files (*.exe)",0,"*.exe",0,"All Files (*.*)",0,"*.*",0)
    mov OFN.lpstrFile, offset szOpenFileBuffer
    mov OFN.nMaxFile, sizeof szOpenFileBuffer
    mov OFN.lpstrTitle, T("Select a file:")
    mov OFN.Flags, OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_LONGNAMES or OFN_HIDEREADONLY
                            

   invoke GetOpenFileName,ADDR OFN
   
   .if eax != 0
    	mov eax, offset szOpenFileBuffer
   .endif
    
    ret

GetFileName  EndP

end start
